#include "testlib.h"
#include <sstream>

using namespace std;

int main(int argc, char * argv[])
{
    setName("compare ordered sequences of signed int%d numbers", 8 * int(sizeof(long long)));

    registerTestlibCmd(argc, argv);

    int n = 0;
    string firstElems;
    vector<int> points;
    while (!ans.seekEof() && !ouf.seekEof())
    {
        n++;
        long long j = ans.readLong();
        long long p = ouf.readLong();
        if (j == p) {
            if (n <= 5) {
                if (firstElems.length() > 0) {
                    firstElems += " ";
                }
                firstElems += vtos(j);
            }
            points.push_back(n - 1);
        }
    }

    int extraInAnsCount = 0;

    while (!ans.seekEof())
    {
        ans.readLong();
        extraInAnsCount++;
    }
    
    int extraInOufCount = 0;

    while (!ouf.seekEof())
    {
        ouf.readLong();
        extraInOufCount++;
    }

    if (extraInAnsCount > 0)
        quitp(_wa, "Answer contains longer sequence [length = %d], but output contains %d elements", n + extraInAnsCount, n);
    
    if (extraInOufCount > 0)
        quitp(_wa, "Output contains longer sequence [length = %d], but answer contains %d elements", n + extraInOufCount, n);
    
    vector<int> points1(10, 3);
    vector<int> points2 = {40, 15, 5, 5, 5};
    int score = 0;
    if (n == 10) {
        for (int i : points) {
            score += points1[i];
        }
    } else if (n == 5) {
        for (int i : points) {
            score += points2[i];
        }
    }
    if (n <= 5)
        quitp(score, "%d number(s): \"%s\"", n, compress(firstElems).c_str());
    else
        quitp(score, "%d numbers", n);
}
