#define _CRT_SECURE_NO_WARNINGS
#include <vector>
#include <string>
#include <set>
#include "testlib.h"
#include <iostream>
using namespace std;

typedef long long ll;

const vector<ll> step = {1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000};

ll get_len(ll a) {
    ll result = 0;
    while (a > 0) {
        result++;
        a /= 10;
    }
    return result;
}

ll mk_fix(ll a, ll b) {
    return step[get_len(b)] * a + b;
}

bool check_field(ll p_res, vector <int> &val, vector <pair<int, int>> &pairs) {
	ll n = val.size() / 2;
	ll result = 0;
    for (auto i : pairs) {
        result += mk_fix(val[i.first-1], val[i.second-1]);
	}
	return p_res == result;
}

int main(int argc, char** argv)
{
	registerTestlibCmd(argc, argv);
	int t = inf.readInt();
	double score = 0;
	for (int test = 0; test < t; ++test) {
		int n = inf.readInt();
		vector <int> val(2 * n);
		for (ll i = 0; i < 2 * n; ++i) {
            val[i] = inf.readInt();
		}
		ll j_res = ans.readLong();
		for (ll turn = 0; turn < 2 * n; ++turn) {
			ans.readInt();
		}
		ll p_res = ouf.readLong();
		if (p_res < 0) {
            quitf(_pe, "jury: wrong res at test %d: %lld", test + 1, p_res);
        }
		vector <pair<int, int>> pairs;
        set<ll> st;
		for (ll turn = 0; turn < n; ++turn) {
			int l = ouf.readInt();
			int r = ouf.readInt();
			if (st.find(l) != st.end()) {
				quitf(_pe, "two pos at test %d: %d", test + 1, l);
			}
            st.insert(l);
            if (st.find(r) != st.end()) {
				quitf(_pe, "two pos at test %d: %d", test + 1, r);
			}
			st.insert(r);    
			//cerr << y << ' ' << x << '\n';
			if (l <= 0 || l > 2 * n) {
				quitf(_pe, "wrong first pos at test %d: %d", test + 1, l);
			}
			if (r <= 0 || r > 2 * n) {
				quitf(_pe, "wrong second pos at test %d: %d", test + 1, r);
			}
			pairs.push_back({l, r});
		}
        if (st.size() < 2 * n) {
            quitf(_pe, "jury: bad positions test: %d", test + 1);
        }
		if (check_field(p_res, val, pairs)) {
			// score += 5;
			// if (p_res > j_res) {
			// 	quitf(_fail, "participant find better at test %d", test + 1);
			// }
			double now_sc = p_res * 1.0 / j_res;
			now_sc = min(now_sc, 1.0);
			now_sc = now_sc * now_sc * now_sc * now_sc;
			score += (30.0 / t) * now_sc;
		}
	}
	quitp(score, "participant's solution is ok");

	return 0;
	
}
